VESA_SIGNATURE			equ	'ASEV'	; VESA reversed
VBE2_SIGNATURE			equ	'2EBV'	; VBE2 reversed

ATTRIB_SUPPORTED		equ	1
ATTRIB_RESERVED			equ	2
ATTRIB_COLOR				equ	8
ATTRIB_GRAPHICS			equ	16
ATTRIB_LINEAR				equ	128

ATTRIBUTES					equ ATTRIB_SUPPORTED + ATTRIB_RESERVED + ATTRIB_COLOR + ATTRIB_GRAPHICS + ATTRIB_LINEAR

SET_LINEAR					equ	4000h

MODE_DIRECT_COLOR		equ 6

VesaInfo	struc
				VesaSig						dd	?		; +0
				VesaVersion				dw	?		; +4
				VesaVendorOffset	dw	?		; +6
				VesaVendorSegment	dw	?		; +8
				VesaCapabilities	dd	?		; +A
				VesaModesOffset		dw	?		; +E
				VesaModesSegment	dw	?		; +10
				VesaMemory				dw	?		; in 64K blocks
VesaInfo	ends

; this structure does not contain all fields that are defined by VESA
VesaMode	struc
				ModeAttributes				dw	?		; +0 (0E 10)
				ModeWindowA						db	?		; +2
				ModeWindowB						db	?		; +3
				ModeWindowGranularity	dw	?		; +4
				ModeWindowSize				dw	?		; +6
				ModeWindowASegment		dw	?		; +8
				ModeWindowBSegment		dw	?		; +A
				ModeWindowFuncOffset	dw	?		; +C
				ModeWindowFuncSegment	dw	?		; +E
				ModeBytesPerScanline	dw	?
				ModeHorizontalRes			dw	?		; from VBE 1.2
				ModeVerticalRes				dw	?
				ModeCharacterWidth		db	?
				ModeCharacterHeight		db	?
				ModeBitPlanes					db	?
				ModeBitsPerPixel			db	?
				ModeNumberOfBanks			db	?
				ModeMemoryModel				db	?
				ModeBankSize					db	?
				ModeNumberOfImagePages	db	?
				ModeReserved					db	1
				ModeRedMaskSize				db	?		; Direct Color fields (required for direct/6 and YUV/7 memory models)
				ModeRedFieldPos				db	?
				ModeGreenMaskSize			db	?
				ModeGreenFieldPos			db	?
				ModeBlueMaskSize			db	?
				ModeBlueFieldPos			db	?
				ModeRsvdMaskSize			db	?
				ModeRsvdFieldPos			db	?
				ModeDirectColorInfo		db	?
				ModePhysBasePtr				dd	?		; from VBE 2.0
				Reserved1							dd	?
				Reserved2							dw	?
				LinBytesPerScanLine		dw	?		; from VBE 3.0
				BnkNumberOfImagePages	db	?
				LinNumberOfImagePages	db	?
				LinRedMaskSize				db	?
				LinRedFieldPos				db	?
				LinGreenMaskSize			db	?
				LinGreenFieldPos			db	?
				LinBlueMaskSize				db	?
				LinBlueFieldPos				db	?
				LinRsvdMaskSize				db	?
				LinRsvdFieldPos				db	?
				MaxPixelClock					dd	?
VesaMode	ends
